using System.Collections.Generic;
using System.Linq;

using LiteDB;

using skydiveLogs_api.Domain;
using skydiveLogs_api.DomainService.Repositories;
using skydiveLogs_api.Infrastructure.Interfaces;


namespace skydiveLogs_api.Infrastructure
{
    public class DropZoneRepository : IDropZoneRepository
    {
        public DropZoneRepository(IDataProvider dataProvider)
        {
            _dataProvider = dataProvider;
            _col = _dataProvider.CollOfDropZone;
        }

        public IEnumerable<DropZone> GetAll()
        {
            return _col.FindAll().ToList();
        }

        public DropZone GetById(int id)
        {
            return _col.FindById(new BsonValue(id));
        }

        public bool Update(DropZone updatedDz)
        {
            return _col.Update(updatedDz);
        }

        public int Add(DropZone newDz)
        {
            int result;

            try
            {
                var tmp = _col.Insert(newDz);
                result = tmp.AsInt32;
            }
            catch
            {
                result = 0;
            }

            return result;
        }

        private readonly IDataProvider _dataProvider;

        private readonly ILiteCollection<DropZone> _col;
    }
}
